/***************************************************************************************
 * Filename: vol.c                                                                     *
 ***************************************************************************************
 * This File is part of the TAON Software and is treated as described in the textfile  *
 * LICENSE, READ IT FOR Coypright INFORMATION and beyond !!!                           *
 ***************************************************************************************
 *  Author: DarKRaveR (aka Sven Eschenberg) <eschenb@informatik.uni-frankfurt.de       *
 ***************************************************************************************/

/***************************************************************************************
 * A really stupid dummy plugin changing the volume of the waveform. it got a fixed    *
 * value of 50% and is meant for plugin recompilation at runtime demonstration         *
 ***************************************************************************************/

#include <TAON_Plugin.h>
#include <stdlib.h>

int TAON_query(struct TAON_PlugInf *info){
         strcpy(info->Name,"Volumizer");
         strcpy(info->Author,"Sven Eschenberg");
         strcpy(info->Copyright,"Copyright 1999 S. Eschenberg");
         strcpy(info->Desc,"Demonstrates compilation and reloading at runtime");
         strcpy(info->Path,"proc/");
         info->Major_Version=0;
         info->Minor_Version=1;
         info->functionality=TAON_Plug_Process;
         info->Host_Version=1;
         strcpy(info->Extend,"");
         return (1);
}

struct TAON_PlugResult *TAON_run(struct TAON_PlugRunParam *params){
        int len;
        int i;
        signed short *left, *right;
	float volume=0.5;

        len=params->Length;
	if (params->Bits==8){
		for (i=0; i<len; i++){
			*(params->Left+i)=(*(params->Left+i)-127)*volume+127;
			if (params->Chan==2){
				*(params->Right+i)=(*(params->Right+i)-127)*volume+127;
			}
		}
	}else{
		left=(signed short *)params->Left;
		right=(signed short *)params->Right;
		for (i=0; i<len/2; i++){
			*(left+i)=*(left+i)*volume;
			if (params->Chan==2){
				*(right+i)=*(right+i)*volume;
			}
		}
	}
			
        return (NULL);
};

